;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Tests for the sourcehut extension.
;;;
;;; Copyright (c) 2019-2020 Evan Hanson
;;;
;;; See LICENSE for details.
;;;

(import (chicken process-context)
        (test)
        (sourcehut))

(let ((sourcehut "sourcehut --help >/dev/null")
      (sourcehut-usage "Usage: sourcehut [options ...] command ..."))
  (import (chicken io)
          (chicken process))
  (test 0 (system sourcehut))
  (let ((output (call-with-input-pipe "sourcehut --help" read-lines)))
    (test-assert (member sourcehut-usage output))))

(unless (get-environment-variable "SRHT_ACCESS_TOKEN")
  (print "skipping remaining tests (no access token)")
  (exit))

(let ()
  (import (sourcehut meta))
  (test-assert (retrieve (profile)))
  (test-assert (retrieve (audit-log)))
  (test-assert (retrieve (ssh-keys)))
  (test-assert (retrieve (pgp-keys))))

(let ()
  (import (sourcehut paste))
  (test-assert (retrieve (pastes))))

(let ()
  (import (sourcehut git))
  (test-assert (retrieve (refs "chicken-sourcehut")))
  (test-assert (retrieve (refs "~evhan" "chicken-sourcehut")))
  (test-assert (retrieve (log "chicken-sourcehut")))
  (test-assert (retrieve (log "~evhan" "chicken-sourcehut"))))

(test-exit)
